YEAR := $(shell date +%Y)
submission submission-main:
- @if [ -n "`ls src/parser/*/generated`" ]; then \
+ @if [ -n "`ls src/parser/*/generated 2>/dev/null`" ]; then \
echo 'ERROR:' >&2; \
echo 'ERROR: Please make maintainer-clean first.' >&2; \
echo 'ERROR:' >&2; \
# main track
mkdir -p cvc4-smtcomp-$(YEAR)
cp -p builds/bin/cvc4 cvc4-smtcomp-$(YEAR)/cvc4
- ( echo '#!/bin/sh'; \
- echo 'exec ./cvc4 -L smt2 --no-checking --no-interactive' ) > cvc4-smtcomp-$(YEAR)/run
+ cp contrib/run-script-smtcomp2012 cvc4-smtcomp-$(YEAR)/run
chmod 755 cvc4-smtcomp-$(YEAR)/run
tar cf cvc4-smtcomp-$(YEAR).tar cvc4-smtcomp-$(YEAR)
submission-application:
# application track is a separate build because it has different preprocessor #defines
- @if [ -n "`ls src/parser/*/generated`" ]; then \
+ @if [ -n "`ls src/parser/*/generated 2>/dev/null`" ]; then \
echo 'ERROR:' >&2; \
echo 'ERROR: Please make maintainer-clean first.' >&2; \
echo 'ERROR:' >&2; \
tar cf cvc4-application-smtcomp-$(YEAR).tar cvc4-application-smtcomp-$(YEAR)
submission-parallel:
# parallel track can't be built with -cln, so it's a separate build
- @if [ -n "`ls src/parser/*/generated`" ]; then \
+ @if [ -n "`ls src/parser/*/generated 2>/dev/null`" ]; then \
echo 'ERROR:' >&2; \
echo 'ERROR: Please make maintainer-clean first.' >&2; \
echo 'ERROR:' >&2; \
--- /dev/null
+#!/bin/bash
+
+cat >bench-$$.smt2
+trap 'rm bench-$$.smt2' EXIT
+
+logic=$(expr "$(head -n 1 bench-$$.smt2)" : '^ *(set-logic *\([A-Z_]*\) *) *$')
+
+# use: trywith [params..]
+# to attempt a run. Only thing printed on stdout is "sat" or "unsat", in
+# which case this run script terminates immediately. Otherwise, this
+# function returns normally.
+function trywith {
+ result="$(./cvc4 -L smt2 --no-checking --no-interactive "$@" bench-$$.smt2)"
+ case "$result" in
+ sat|unsat) echo "$result"; exit 0;;
+ esac
+}
+
+# use: finishwith [params..]
+# to run cvc4 and let it output whatever it will to stdout.
+function finishwith {
+ ./cvc4 -L smt2 --no-checking --no-interactive "$@" bench-$$.smt2
+}
+
+case "$logic" in
+
+QF_LRA)
+ # 10 minutes with default decision heuristic
+ trywith --tlimit-per=600000
+ # switch to internal decision heuristic
+ finishwith --decision=internal
+ ;;
+AUFLIA)
+ # 60 seconds with default decision heuristic
+ trywith --tlimit-per=60000
+ # try simplification for 60 seconds, default decision heuristic
+ trywith --simplification=batch --tlimit-per=60000
+ # switch to internal decision heuristic
+ finishwith --decision=internal
+ ;;
+QF_AUFBV)
+ trywith --tlimit-per=600000
+ finishwith --decision=justification-stoponly
+ ;;
+*)
+ # just run the default
+ finishwith
+ ;;
+
+esac
+